Imports Telerik.WebAii.Controls.Html
Imports Telerik.WebAii.Controls.Xaml
Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Linq

Imports ArtOfTest.Common.UnitTesting
Imports ArtOfTest.WebAii.Core
Imports ArtOfTest.WebAii.Controls.HtmlControls
Imports ArtOfTest.WebAii.Controls.HtmlControls.HtmlAsserts
Imports ArtOfTest.WebAii.Design
Imports ArtOfTest.WebAii.Design.Execution
Imports ArtOfTest.WebAii.ObjectModel
Imports ArtOfTest.WebAii.Silverlight
Imports ArtOfTest.WebAii.Silverlight.UI


    '
    ' You can add custom execution steps by simply
    ' adding a 'Sub' routine and decorating it with the <CodedStep("Description")>
    ' attribute to the test method. 
    ' Those steps will automatically show up in the test steps on save.
    '
    ' The BaseWebAiiTest exposes all key objects that you can use
    ' to access the current testcase context. [i.e. ActiveBrowser, Find ..etc]
    '
    ' Data driven tests can use the Data(columnIndex) or Data("columnName") 
    ' to access data for a specific data iteration.
    '
    ' Example:
    '
    ' <CodedStep("MyCustom Step Description")> Public Sub MyTestMethod()
    ' 
    '       // Custom code goes here
    '      ActiveBrowser.NavigateTo("http://www.google.com")
    '
    '       // Or
    '       ActiveBrowser.NavigateTo(Data("url"))
    '
    ' End Sub
    '
    Public Class CrumbTray_OwnershipClickAndVerification
        Inherits BaseWebAiiTest
        Private pageLoadTimeOut as Integer
        
#Region "[ Dynamic Pages Reference ]"

        Private _pages As Pages
        private testPageUrl As String
        
        '''<summary>
        ''' Gets the Pages object that has references
        ''' to all the elements, frames or regions
        ''' in this project.
        '''</summary>
        Public ReadOnly Property Pages() As Pages
            Get
                If (_pages Is Nothing) Then
                    _pages = New Pages(Manager.Current)
                End If
                Return _pages
            End Get
        End Property
        
#End Region
        
        ' Add your test methods here...

        ' Add your test methods here...

        
        private sub ClickAndVerifyLinksInOwnershipPart(linkName As String,pageUrlkeyWord As String,element As String)
            Dim OwnershipLi As HtmlDiv
            Dim linksUl As HtmlUnorderedList
            Dim link As HtmlAnchor
            Dim islinkCorrect As Boolean = true
         
            ActiveBrowser.WaitForElement(new HtmlFindExpression("class=ng-widget brand-footer brand-footer"),pageLoadTimeOut,false)
            OwnershipLi = Find.ByExpression(of htmldiv)("class=ng-widget brand-footer brand-footer")
          '  linksUl = OwnershipLi.Find.ByExpression(of HtmlUnorderedList)("class=links") 
            link = OwnershipLi.Find.ByAttributes(of HtmlAnchor)("href=~"+pageUrlkeyWord)
            log.WriteLine("Debug: "+link.BaseElement.OuterMarkup)
            'click link
            try
            link.Click
              ActiveBrowser.WaitUntilReady
            System.Threading.Thread.Sleep(2000)
            'wait for new page element to load
            ActiveBrowser.WaitForElement(new HtmlFindExpression(element),15000,false)
            catch ex As Exception
                 islinkCorrect= false
                log.WriteLine("This message can be ignored:"&ex.Message)
          
            End try
           if not link.BaseElement.InnerText.EndsWith(linkName)
             islinkCorrect= false
            log.WriteLine("Error: the link name displayed not expected!!!as "+linkName)
        End if
            if not VerifyPageUrl(pageUrlkeyWord)
                islinkCorrect= false
            End if
            ActiveBrowser.NavigateTo(testPageUrl)
            ActiveBrowser.WaitUntilReady
            Assert.IsTrue(islinkCorrect)
        End sub
    
    
        private Function VerifyPageUrl(pageUrlkeyWord As String)
            Dim isPageUrlCorrect As Boolean = true
           ActiveBrowser.WaitUntilReady
            'do the page load verification
            if not PageLoadVerification() 
                isPageUrlCorrect = false
            End if

            'verify page url
            try
                 ActiveBrowser.WaitForUrl(pageUrlkeyWord,true,17000)
                catch ex as Exception
            if ex.Message.Contains("Wait for condition has timed out")
                isPageUrlCorrect = false
                log.WriteLine("The page url is not correct.Expected url contains: "+pageUrlkeyWord+" ;Actual url is: "+ActiveBrowser.Url)
            End if
        end try

            return isPageUrlCorrect
        End Function
    
        Private function PageLoadVerification() As Boolean                
            Dim isRight As Boolean
            isRight = true
            If(ActiveBrowser.ContainsText("Oops")) Then
                If not ActiveBrowser.PageTitle.Contains("Ford Accessories")
                    log.WriteLine("Page is navigate to Oops page" + ActiveBrowser.Url)     
                    isRight = false
                End if
            Else If(ActiveBrowser.ContainsText("HTTP 400")) Then
              log.WriteLine("Page has Error 400" + ActiveBrowser.Url)
              isRight = false
            Else If(ActiveBrowser.ContainsText("HTTP 404")) Then
              log.WriteLine("Page has Error 404" + ActiveBrowser.Url)
              isRight = false 
            Else If(ActiveBrowser.ContainsText("500 Internal Server Error")) Then
              log.WriteLine("Page has Error 500" + ActiveBrowser.Url)
              isRight = false
            Else If(ActiveBrowser.ContainsText("HTTP Error")) Then
              log.WriteLine("HTTP Error" + ActiveBrowser.Url)
              isRight = false
            End If       
            Return isRight
        End function
    

        <CodedStep("init test page url")> _
        Public Sub CrumbTray_OwnershipClickAndVerification_CodedStep()
             testPageUrl = "http://wwwqa.ford.com"
         ActiveBrowser.NavigateTo(testPageUrl)
       
        pageLoadTimeOut = 15000
        End Sub

        <CodedStep("click and verify 'Support' link ")> _
        Public Sub CrumbTray_OwnershipClickAndVerification_CodedStep1()
            ClickAndVerifyLinksInOwnershipPart("Support","support","class=fls-content fls-homepage clearer")
        End Sub


        <CodedStep("click and verify 'Service' link ")> _
        Public Sub CrumbTray_OwnershipClickAndVerification_CodedStep4()
            ClickAndVerifyLinksInOwnershipPart("Service","genuineservice","id=login-btn-wrap")
        End Sub


        <CodedStep("click and verify 'Warranty & Service Plans' link ")> _
        Public Sub CrumbTray_OwnershipClickAndVerification_CodedStep7()
            ClickAndVerifyLinksInOwnershipPart("Warranty &amp; Service Plans","extended-service-plans","id=logo")
        End Sub


        <CodedStep("click and verify 'Accessories Store' link ")> _
        Public Sub CrumbTray_OwnershipClickAndVerification_CodedStep10()
            ClickAndVerifyLinksInOwnershipPart("Accessories Store","accessories.ford.com","class=block-title")
        End Sub


        <CodedStep("click and verify 'FordParts.com' link ")> _
        Public Sub CrumbTray_OwnershipClickAndVerification_CodedStep13()
            ClickAndVerifyLinksInOwnershipPart("FordParts.com","fordparts","class=SiteLogo")
        End Sub


        <CodedStep("click and verify'Make a Payment' link")> _
        Public Sub CrumbTray_OwnershipClickAndVerification_CodedStep16()
            ClickAndVerifyLinksInOwnershipPart("Make a Payment","servlet/ContentServer?pagename=Owner/Page/AccountOverviewPage","id=login-btn-wrap")
        End Sub


        <CodedStep("click and verify 'MyFord eMagazine' link ")> _
        Public Sub CrumbTray_OwnershipClickAndVerification_CodedStep19()   
            ClickAndVerifyLinksInOwnershipPart("MyFord eMagazine","myfordmag","class=logo")
        End Sub


        <CodedStep("click and verify 'Safety Recalls' link ")> _
        Public Sub CrumbTray_OwnershipClickAndVerification_CodedStep2()
            ClickAndVerifyLinksInOwnershipPart("Safety Recalls","servlet/ContentServer?pagename=Owner/Page/RecallsPage","id=yui-main")
        End Sub
End Class